function [  ] = Calculate4DirectionSobelPrewittDescriptor( rt_img_dir, rt_data_dir, patchSize, fea_dim, cellNum)



disp('Extracting Sobel features...');
subfolders = dir(rt_img_dir);

parfor ii = 1:length(subfolders),
    subname = subfolders(ii).name;
    patchNum = 361;
    if ~strcmp(subname, '.') && ~strcmp(subname, '..'),

        
        display(subname);

        %frames = dir(fullfile(rt_img_dir, subname, '*.jpg'));
        frames = dir(fullfile(rt_img_dir, subname, '*.bmp'));
        
        c_num = length(frames);           

        
        sobelpath = fullfile(rt_data_dir, subname);        
        if ~isdir(sobelpath),
            mkdir(sobelpath);
        end;
        
        for jj = 1:c_num,
            imgpath = fullfile(rt_img_dir, subname, frames(jj).name);
            
            [pdir, fname,ext] = fileparts(frames(jj).name);
            fpath = fullfile(rt_data_dir, subname, [fname, '.mat']); 

            if(exist(fpath))
       %         continue;
            end
            
            I = imread(imgpath);
            
            [im_h, im_w] = size(I);
            I = 1 - I;
         %   sobel_operator = [-1 -2 -1; 0 0 0; 1 2 1];
         %   prewitt_operator = [-1 -1 -1; 0 0 0; 1 1 1];
            sobel_0_operator = [-1 -2 -1; 0 0 0; 1 2 1];
            sobel_90_operator = [1 0 -1; 2 0 -2; 1 0 -1];
            sobel_45_operator = [2 1 0; 1 0 -1; 0 -1 -2];
            sobel_135_operator = [0 -1 2; 1 0 -1; 2 1 0];
            
            prewitt_0_operator = [-1 -1 -1; 0 0 0; 1 1 1];
            prewitt_90_operator = [1 0 -1; 1 0 -1; 1 0 -1];
            prewitt_45_operator = [1 1 0; 1 0 -1; 0 -1 -1];
            prewitt_135_operator = [0 -1 1; 1 0 -1; 1 1 0];
            
            sobel_0 = filter2(sobel_0_operator,I,'same');
            sobel_90 = filter2(sobel_90_operator,I,'same');
            sobel_45 = filter2(sobel_45_operator,I,'same');
            sobel_135 = filter2(sobel_135_operator,I,'same');
            
            sobel_mag_0_90 = sqrt(sobel_0.^2 + sobel_90.^2);
            sobel_theta_0_90 = atan2(sobel_90,sobel_0);
            sobel_mag_45_135 = sqrt(sobel_45.^2 + sobel_135.^2);
            sobel_theta_45_135 = atan2(sobel_135,sobel_45);
            
            sobel_mag_padded_0_90 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            sobel_theta_padded_0_90 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            sobel_mag_padded_45_135 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            sobel_theta_padded_45_135 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            
            sobel_mag_padded_0_90(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = sobel_mag_0_90;
            sobel_theta_padded_0_90(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = sobel_theta_0_90;
            sobel_mag_padded_45_135(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = sobel_mag_45_135;
            sobel_theta_padded_45_135(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = sobel_theta_45_135;
            
            prewitt_0 = filter2(prewitt_0_operator,I,'same');
            prewitt_90 = filter2(prewitt_90_operator,I,'same');
            prewitt_45 = filter2(prewitt_45_operator,I,'same');
            prewitt_135 = filter2(prewitt_135_operator,I,'same');
            
            prewitt_mag_0_90 = sqrt(prewitt_0.^2 + prewitt_90.^2);
            prewitt_theta_0_90 = atan2(prewitt_90,prewitt_0);
            prewitt_mag_45_135 = sqrt(prewitt_45.^2 + prewitt_135.^2);
            prewitt_theta_45_135 = atan2(prewitt_135,prewitt_45);
            
            prewitt_mag_padded_0_90 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            prewitt_theta_padded_0_90 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            prewitt_mag_padded_45_135 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            prewitt_theta_padded_45_135 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            
            prewitt_mag_padded_0_90(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = prewitt_mag_0_90;
            prewitt_theta_padded_0_90(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = prewitt_theta_0_90;
            prewitt_mag_padded_45_135(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = prewitt_mag_45_135;
            prewitt_theta_padded_45_135(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = prewitt_theta_45_135;
            
            
            patch_num = numel(find(sobel_mag_padded_0_90 > 0));
             if(patch_num < patchNum)
                patchNum = patch_num;
            end
            select_arr = randperm(patch_num, patchNum);
            
            
            patch_x_arr = zeros(patchNum,1);
            patch_y_arr = zeros(patchNum,1);
            Fea_Arr = zeros(patchNum,fea_dim);
            patch_idx = 1;
            patch_arr_idx = 1;
            
%             subplot(1,2,1);
%             imshow(I);
%             
%             subplot(1,2,2);
        %    I_interestPoint = im2bw(I_interestPoint,0.7);
            %imshow(I_interestPoint);
            
            for patch_ii = patchSize/2+2:patchSize/2+2+im_h-1
                for patch_jj = patchSize/2+2:patchSize/2+2+im_w-1
                    pick2 = sobel_mag_padded_0_90(patch_ii,patch_jj) > 0;
                    if(pick2)
                    if(numel(find(select_arr == patch_idx)))
                        patch_x_arr(patch_arr_idx,:) = patch_ii - patchSize/2 - 1;
                        patch_y_arr(patch_arr_idx,:) = patch_jj - patchSize/2 - 1;
                        patch_sobel_mag_0_90 = sobel_mag_padded_0_90(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_sobel_theta_0_90 = sobel_theta_padded_0_90(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_sobel_mag_45_135 = sobel_mag_padded_45_135(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_sobel_theta_45_135 = sobel_theta_padded_45_135(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        
                        patch_prewitt_mag_0_90 = prewitt_mag_padded_0_90(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_prewitt_theta_0_90 = prewitt_theta_padded_0_90(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_prewitt_mag_45_135 = prewitt_mag_padded_45_135(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_prewitt_theta_45_135 = prewitt_theta_padded_45_135(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        
                        patch_sobel_cell_arr_0_90 = CalculateSobelFeatures(patch_sobel_mag_0_90,patch_sobel_theta_0_90,cellNum);
                        patch_prewitt_cell_arr_0_90 = CalculateSobelFeatures(patch_prewitt_mag_0_90,patch_prewitt_theta_0_90,cellNum);
                        patch_sobel_cell_arr_45_135 = CalculateSobelFeatures(patch_sobel_mag_45_135,patch_sobel_theta_45_135,cellNum);
                        patch_prewitt_cell_arr_45_135 = CalculateSobelFeatures(patch_prewitt_mag_45_135,patch_prewitt_theta_45_135,cellNum);
                        
                        Fea_Arr(patch_arr_idx,1:256) = patch_sobel_cell_arr_0_90;
                      %  Fea_Arr(patch_arr_idx,257:512) = patch_prewitt_cell_arr_0_90
                        Fea_Arr(patch_arr_idx,257:512) = patch_sobel_cell_arr_45_135;
                        Fea_Arr(patch_arr_idx,513:768) = patch_prewitt_cell_arr_0_90;
                        Fea_Arr(patch_arr_idx,769:1024) = patch_prewitt_cell_arr_45_135;
                       
                        patch_arr_idx = patch_arr_idx + 1;
                    end
                    patch_idx = patch_idx + 1;
                    end
                end
            end

            feaSet = struct;
            feaSet.feaArr = Fea_Arr';
            feaSet.x = patch_x_arr;
            feaSet.y = patch_y_arr;
            feaSet.width = im_w;
            feaSet.height = im_h;
            
            CalSobelDesc_save(fpath,feaSet);
        end;    
    end;

end
