function [  ] = Calculate4DirectionSobelPrewittDescriptorHarris( rt_img_dir, rt_data_dir, patchSize, fea_dim, patchNum, cellNum)



disp('Extracting Sobel features...');
subfolders = dir(rt_img_dir);

%txt_dir = 'G:\song\grade2_1\SCCFR\SCCFR\SCCFR_driver\points_fix';

parfor ii = 1:length(subfolders),
    subname = subfolders(ii).name;
    patchNum = 361;
    if ~strcmp(subname, '.') && ~strcmp(subname, '..'),

        
        display(subname);

        %frames = dir(fullfile(rt_img_dir, subname, '*.jpg'));
        frames = dir(fullfile(rt_img_dir, subname, '*.bmp'));
        
        c_num = length(frames);           

        
        sobelpath = fullfile(rt_data_dir, subname);        
        if ~isdir(sobelpath),
            mkdir(sobelpath);
        end;
        
        for jj = 1:c_num,
            imgpath = fullfile(rt_img_dir, subname, frames(jj).name);
            
            [pdir, fname,ext] = fileparts(frames(jj).name);
            fpath = fullfile(rt_data_dir, subname, [fname, '.mat']); 

            if(exist(fpath))
       %         continue;
            end
            
            I = imread(imgpath);

            img=I;
            [m n]=size(img);

            tmp=zeros(m+2,n+2);
            tmp(2:m+1,2:n+1)=img;
            Ix=zeros(m+2,n+2);
            Iy=zeros(m+2,n+2);

            E=zeros(m+2,n+2);

            Ix(:,2:n)=tmp(:,3:n+1)-tmp(:,1:n-1);
            Iy(2:m,:)=tmp(3:m+1,:)-tmp(1:m-1,:);

            Ix2=Ix(2:m+1,2:n+1).^2;
            Iy2=Iy(2:m+1,2:n+1).^2;
            Ixy=Ix(2:m+1,2:n+1).*Iy(2:m+1,2:n+1);

            h=fspecial('gaussian',[7 7],2);
            Ix2=filter2(h,Ix2);
            Iy2=filter2(h,Iy2);
            Ixy=filter2(h,Ixy);

            Rmax=0;
            R=zeros(m,n);
            for i=1:m
                for j=1:n
                    M=[Ix2(i,j) Ixy(i,j);Ixy(i,j) Iy2(i,j)];
                    R(i,j)=det(M)-0.06*(trace(M))^2;
        
                    if R(i,j)>Rmax
                        Rmax=R(i,j);
                    end
                end
            end
            re=zeros(m+2,n+2);

            tmp(2:m+1,2:n+1)=R;
            img_re=zeros(m+2,n+2);
            img_re(2:m+1,2:n+1)=img;
            for i=2:m+1
                for j=2:n+1
        
                    if tmp(i,j)>0.01*Rmax &&...
                        tmp(i,j)>tmp(i-1,j-1) && tmp(i,j)>tmp(i-1,j) && tmp(i,j)>tmp(i-1,j+1) &&...
                        tmp(i,j)>tmp(i,j-1) && tmp(i,j)>tmp(i,j+1) &&...
                        tmp(i,j)>tmp(i+1,j-1) && tmp(i,j)>tmp(i+1,j) && tmp(i,j)>tmp(i+1,j+1)
                        img_re(i,j)=255; 
                    end
          
                end
            end

    %        figure,imshow(mat2gray(img_re(2:m+1,2:n+1)));
            [im_h, im_w] = size(I);
            I = 1 - I;
         %   sobel_operator = [-1 -2 -1; 0 0 0; 1 2 1];
         %   prewitt_operator = [-1 -1 -1; 0 0 0; 1 1 1];
            sobel_0_operator = [-1 -2 -1; 0 0 0; 1 2 1];
            sobel_90_operator = [1 0 -1; 2 0 -2; 1 0 -1];
            sobel_45_operator = [2 1 0; 1 0 -1; 0 -1 -2];
            sobel_135_operator = [0 -1 2; 1 0 -1; 2 1 0];
            
            prewitt_0_operator = [-1 -1 -1; 0 0 0; 1 1 1];
            prewitt_90_operator = [1 0 -1; 1 0 -1; 1 0 -1];
            prewitt_45_operator = [1 1 0; 1 0 -1; 0 -1 -1];
            prewitt_135_operator = [0 -1 1; 1 0 -1; 1 1 0];
            
            sobel_0 = filter2(sobel_0_operator,I,'same');
            sobel_90 = filter2(sobel_90_operator,I,'same');
            sobel_45 = filter2(sobel_45_operator,I,'same');
            sobel_135 = filter2(sobel_135_operator,I,'same');
            
            sobel_mag_0_90 = sqrt(sobel_0.^2 + sobel_90.^2);
            sobel_theta_0_90 = atan2(sobel_90,sobel_0);
            sobel_mag_45_135 = sqrt(sobel_45.^2 + sobel_135.^2);
            sobel_theta_45_135 = atan2(sobel_135,sobel_45);
            
            sobel_mag_padded_0_90 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            sobel_theta_padded_0_90 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            sobel_mag_padded_45_135 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            sobel_theta_padded_45_135 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            
            sobel_mag_padded_0_90(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = sobel_mag_0_90;
            sobel_theta_padded_0_90(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = sobel_theta_0_90;
            sobel_mag_padded_45_135(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = sobel_mag_45_135;
            sobel_theta_padded_45_135(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = sobel_theta_45_135;
            
            prewitt_0 = filter2(prewitt_0_operator,I,'same');
            prewitt_90 = filter2(prewitt_90_operator,I,'same');
            prewitt_45 = filter2(prewitt_45_operator,I,'same');
            prewitt_135 = filter2(prewitt_135_operator,I,'same');
            
            prewitt_mag_0_90 = sqrt(prewitt_0.^2 + prewitt_90.^2);
            prewitt_theta_0_90 = atan2(prewitt_90,prewitt_0);
            prewitt_mag_45_135 = sqrt(prewitt_45.^2 + prewitt_135.^2);
            prewitt_theta_45_135 = atan2(prewitt_135,prewitt_45);
            
            prewitt_mag_padded_0_90 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            prewitt_theta_padded_0_90 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            prewitt_mag_padded_45_135 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            prewitt_theta_padded_45_135 = zeros(im_h+patchSize+4, im_w+patchSize+4);
            
            prewitt_mag_padded_0_90(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = prewitt_mag_0_90;
            prewitt_theta_padded_0_90(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = prewitt_theta_0_90;
            prewitt_mag_padded_45_135(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = prewitt_mag_45_135;
            prewitt_theta_padded_45_135(patchSize/2+2:patchSize/2+2+im_h-1, patchSize/2+2:patchSize/2+2+im_w-1) = prewitt_theta_45_135;
            
            
            patch_num = numel(find(img_re > 0));
             if(patch_num < patchNum)
                patchNum = patch_num;
            end
            select_arr = randperm(patch_num, patchNum);
            
            
            patch_x_arr = zeros(patchNum,1);
            patch_y_arr = zeros(patchNum,1);
            Fea_Arr = zeros(patchNum,fea_dim);
            patch_idx = 1;
            patch_arr_idx = 1;
            
            for patch_i = 1:im_h
                for patch_j = 1:im_w
                    if(img_re(patch_i+1,patch_j+1) > 100)
                        patch_ii = patch_i + patchSize/2 + 1;
                        patch_jj = patch_j + patchSize/2 + 1;
                        patch_x_arr(patch_arr_idx,:) = patch_ii - patchSize/2 - 1;
                        patch_y_arr(patch_arr_idx,:) = patch_jj - patchSize/2 - 1;
                        patch_sobel_mag_0_90 = sobel_mag_padded_0_90(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_sobel_theta_0_90 = sobel_theta_padded_0_90(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_sobel_mag_45_135 = sobel_mag_padded_45_135(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_sobel_theta_45_135 = sobel_theta_padded_45_135(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        
                        patch_prewitt_mag_0_90 = prewitt_mag_padded_0_90(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_prewitt_theta_0_90 = prewitt_theta_padded_0_90(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_prewitt_mag_45_135 = prewitt_mag_padded_45_135(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        patch_prewitt_theta_45_135 = prewitt_theta_padded_45_135(patch_ii-patchSize/2:patch_ii-patchSize/2+patchSize-1,patch_jj-patchSize/2:patch_jj-patchSize/2+patchSize-1);
                        
                        patch_sobel_cell_arr_0_90 = CalculateSobelFeatures(patch_sobel_mag_0_90,patch_sobel_theta_0_90,cellNum);
                        patch_prewitt_cell_arr_0_90 = CalculateSobelFeatures(patch_prewitt_mag_0_90,patch_prewitt_theta_0_90,cellNum);
                        patch_sobel_cell_arr_45_135 = CalculateSobelFeatures(patch_sobel_mag_45_135,patch_sobel_theta_45_135,cellNum);
                        patch_prewitt_cell_arr_45_135 = CalculateSobelFeatures(patch_prewitt_mag_45_135,patch_prewitt_theta_45_135,cellNum);
                        
                        Fea_Arr(patch_arr_idx,1:256) = patch_sobel_cell_arr_0_90;
                      %  Fea_Arr(patch_arr_idx,257:512) = patch_prewitt_cell_arr_0_90
                        Fea_Arr(patch_arr_idx,257:512) = patch_sobel_cell_arr_45_135;
                        Fea_Arr(patch_arr_idx,513:768) = patch_prewitt_cell_arr_0_90;
                        Fea_Arr(patch_arr_idx,769:1024) = patch_prewitt_cell_arr_45_135;
                       
                        patch_arr_idx = patch_arr_idx + 1;
                    end
                end
            end

            feaSet = struct;
            feaSet.feaArr = Fea_Arr';
            feaSet.x = patch_x_arr;
            feaSet.y = patch_y_arr;
            feaSet.width = im_w;
            feaSet.height = im_h;
            
            CalSobelDesc_save(fpath,feaSet);
        end;    
    end;

end
