clc;clear all;

source_dirs = {'SP_4_dir_P8_F160_8x8_features_par/Fonts';'SP_4_dir_P16_F160_8x8_features_par/Fonts';'SP_4_dir_P32_F160_8x8_features_par/Fonts'};
weights = [1,1,1];

nSrc_dir = size(source_dirs,1);
fea_len = 21504*nSrc_dir;
dist_dir = 'SP_4_dir_P8_16_32_F160_8x8_features_par/Fonts';

disp('Extracting Sobel features...');

source_dir = source_dirs{1};

subfolders = dir(source_dir);


parfor ii = 1:length(subfolders),
  
    subname = subfolders(ii).name;
    
    if ~strcmp(subname, '.') && ~strcmp(subname, '..'),

        
        display(subname);
        
        frames = dir(fullfile(source_dir, subname, '*.mat'));
        
        c_num = length(frames);           

        
        feapath = fullfile(dist_dir, subname);        
        if ~isdir(feapath),
            mkdir(feapath);
        end;
        
        conc_fea_vec = zeros(fea_len,1);
        conc_fea_label = 0;
        for jj = 1:c_num,
            for kk = 1:nSrc_dir
            matpath = fullfile(source_dirs{kk}, subname, frames(jj).name);
            feature = load(matpath);
            nfea = size(feature.fea,1);
            conc_fea_vec((kk-1)*nfea+1:kk*nfea) = feature.fea;
            conc_fea_label = feature.label;
            end
            fpath = fullfile(dist_dir,subname,frames(jj).name);
            multiscale_concatenate_save(fpath, conc_fea_vec,conc_fea_label);
        end
    end
end
